import { PropertyValueMap } from "lit";
import { FRoot } from "../../mixins/components/f-root/f-root";
import { FPopover } from "../f-popover/f-popover";
import { FDiv } from "../f-div/f-div";
export type FColorPickerState = "primary" | "default" | "success" | "warning" | "danger";
export type FColorPickerInputEvent = {
    value?: string;
};
export declare class FColorPicker extends FRoot {
    /**
     * css loaded from scss file
     */
    static styles: import("lit").CSSResult[];
    /**
     * @attribute Variants are various visual representations of an input field.
     */
    variant?: "curved" | "round" | "block";
    /**
     * @attribute States are used to communicate purpose and connotations.
     */
    state?: FColorPickerState;
    /**
     * @attribute f-input can have 2 sizes. By default size is inherited by the parent f-field.
     */
    size?: "medium" | "small";
    /**
     * @attribute Defines the value of an f-input. Validation rules are applied on the value depending on the type property of the f-text-input.
     */
    value?: string;
    /**
     * @attribute Shows disabled state of input element
     */
    disabled?: boolean;
    /**
     * @attribute When true the user can not select the input element.
     */
    readOnly?: boolean;
    popoverElement: FPopover;
    isOpen: boolean;
    inputElement: FDiv;
    defaultHexColor: string;
    handleColorChange(event: CustomEvent<{
        value: string;
    }>): void;
    handleFocus(_event: FocusEvent): void;
    handleOverlayClick(): void;
    handleHexInput(event: CustomEvent): void;
    handleKeydown(event: KeyboardEvent): void;
    dispatchInputEvent(value?: string): void;
    get isValueEmpty(): boolean | "";
    sizeMap: {
        small: string;
        medium: string;
    };
    get colorPickerTypeTemplate(): import("lit-html").TemplateResult<1>;
    protected willUpdate(changedProperties: PropertyValueMap<any> | Map<PropertyKey, unknown>): void;
    render(): import("lit-html").TemplateResult<1>;
    protected updated(changedProperties: PropertyValueMap<any> | Map<PropertyKey, unknown>): void;
}
/**
 * Required for typescript
 */
declare global {
    interface HTMLElementTagNameMap {
        "f-color-picker": FColorPicker;
    }
}
